public class NameAllocator {

    private int numAllocated;
    private String prefix;

    private NameAllocator(String prefix){
        this.prefix = prefix;
        this.numAllocated = 0;
    }

    public String next(){
        return prefix + numAllocated++;
    }

    public int getNumAllocated(){
        return numAllocated;
    }

    public void reset(){
        numAllocated = 0;
    }

    private static NameAllocator tempAllocator = new NameAllocator("$t");
    private static NameAllocator savedAllocator = new NameAllocator("$s");
    private static NameAllocator labelAllocator = new NameAllocator("label_");

    public static NameAllocator getTempAllocator(){
        return tempAllocator;
    }

    public static NameAllocator getSavedAllocator(){
        return savedAllocator;
    }

    public static NameAllocator getLabelAllocator(){
        return labelAllocator;
    }
}
